searchData={"items":[{"type":"module","title":"TalkJS","doc":"Elixir SDK for Talkjs. See https://talkjs.com/docs/Reference/REST_API/","ref":"TalkJS.html"},{"type":"module","title":"Installation - TalkJS","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `talkjs` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:talkjs, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"TalkJS.html#module-installation"},{"type":"function","title":"TalkJS.new/1","doc":"Create a new TalkJS client\n\nOptions for the TalkJS client:application\n  * `:api_key` - the API key provided by TalkJS (YOUR_SECRET_KEY)\n  * `:app_id` - the app id provided by TalkJS (YOUR_APP_ID)\n  * `:base_url` - the base URL for the API (default: \"https://api.talkjs.com/v1/\")\n  * `:http_client` - the HTTP client to use (default: TalkJS.HTTPClient.HTTPC).\n    Must adhere to `TalkJS.HTTPClient` behaviour\n\nExample usage:\n\n```elixir\n  client = TalkJS.new(api_key: \"...\", app_id: \"...\")\n```","ref":"TalkJS.html#new/1"},{"type":"function","title":"TalkJS.request/5","doc":"Perform a request to TalkJS\n\nExample usage:\n\n```elixir\n  client = TalkJS.new(api_key: \"...\", app_id: \"...\")\n\n  TalkJS.request(:get, \"$app_id/users/#id\", client, %{})\n```","ref":"TalkJS.html#request/5"},{"type":"type","title":"TalkJS.t/0","doc":"TalkJS config","ref":"TalkJS.html#t:t/0"},{"type":"module","title":"TalkJS.Conversation","doc":"Module to access the /conversations/ endpoints","ref":"TalkJS.Conversation.html"},{"type":"function","title":"TalkJS.Conversation.create_or_update/3","doc":"Create or update a conversation\n\n```elixir\n  client = TalkJS.new(api_key: \"...\", app_id: \"...\")\n  TalkJS.Conversation.create_or_update(client, \"695388f0e3481bcd93\", %{})\n```","ref":"TalkJS.Conversation.html#create_or_update/3"},{"type":"behaviour","title":"TalkJS.HTTPClient","doc":"Behaviour for HTTP clients.","ref":"TalkJS.HTTPClient.html"},{"type":"callback","title":"TalkJS.HTTPClient.init/0","doc":"","ref":"TalkJS.HTTPClient.html#c:init/0"},{"type":"callback","title":"TalkJS.HTTPClient.request/5","doc":"","ref":"TalkJS.HTTPClient.html#c:request/5"},{"type":"module","title":"TalkJS.IdentityVerification","doc":"Secure the identity of your user","ref":"TalkJS.IdentityVerification.html"},{"type":"function","title":"TalkJS.IdentityVerification.signature/2","doc":"Returns signature of a user identify.\n\nFirst argument accepts a value that conforms to the TalkJS.UserIdentity protocol.","ref":"TalkJS.IdentityVerification.html#signature/2"},{"type":"function","title":"Examples - TalkJS.IdentityVerification.signature/2","doc":"iex> TalkJS.IdentityVerification.signature(123, \"YOUR_SECRET_KEY\")\n    \"cca5c5faf36a62306e4d24a5b28ae7071aca7bccc3af512309320807d113bc8c\"","ref":"TalkJS.IdentityVerification.html#signature/2-examples"},{"type":"module","title":"TalkJS.User","doc":"Module to access the /users/ endpoints","ref":"TalkJS.User.html"},{"type":"function","title":"TalkJS.User.create_or_update/3","doc":"Create or update user","ref":"TalkJS.User.html#create_or_update/3"},{"type":"function","title":"Examples - TalkJS.User.create_or_update/3","doc":"```elixir\n  client = TalkJS.new(api_key: \"...\", app_id: \"...\")\n  TalkJS.User.create_or_update(client, \"df695388f0e3481bcd93\", %{name: \"John Doe\"})\n```","ref":"TalkJS.User.html#create_or_update/3-examples"},{"type":"protocol","title":"TalkJS.UserIdentity","doc":"Protocol for getting user identity identifier from a struct.","ref":"TalkJS.UserIdentity.html"},{"type":"function","title":"TalkJS.UserIdentity.user_id/1","doc":"","ref":"TalkJS.UserIdentity.html#user_id/1"},{"type":"type","title":"TalkJS.UserIdentity.t/0","doc":"All the types that implement this protocol.","ref":"TalkJS.UserIdentity.html#t:t/0"},{"type":"module","title":"TalkJS.Webhook","doc":"This module provides a function for verifying webhook signatures.\n\nSee https://hexdocs.pm/plug/Plug.Parsers.html#module-custom-body-reader\non how to read the raw request body in a Plug pipeline.","ref":"TalkJS.Webhook.html"},{"type":"function","title":"TalkJS.Webhook.verify/5","doc":"Verify the signature of a webhook request.","ref":"TalkJS.Webhook.html#verify/5"},{"type":"function","title":"Options - TalkJS.Webhook.verify/5","doc":"* `:now` - Timestamp in milliseconds. Defaults to `System.system_time(:millisecond)`\n  * `:tolerance` - Tolerance in seconds. Defaults to 300 seconds.","ref":"TalkJS.Webhook.html#verify/5-options"},{"type":"function","title":"Examples - TalkJS.Webhook.verify/5","doc":"iex> TalkJS.Webhook.verify(\"B7A1EEE018DD10159EADFF74E7E324DFCD5600F35D4744F440B892507724DBA0\", raw_body(), 1663417005267, \"sk_abc\", [now: 1663417005268])\n    :ok\n\n    iex> TalkJS.Webhook.verify(\"B7A1EEE018DD10159EADFF74E7E324DFCD5600F35D4744F440B892507724DBA0\", raw_body(), 1663417005267, \"sk_abc\", [now: 1603417005268])\n    {:error, \"Timestamp outside the tolerance zone\"}\n\n    iex> TalkJS.Webhook.verify(\"bogus\", raw_body(), 1663417005267, \"sk_abc\", [now: 1663417005268])\n    {:error, \"Signature did not match expected signature\"}","ref":"TalkJS.Webhook.html#verify/5-examples"}],"content_type":"text/markdown"}